## xcp-storage-managers 0.1.1

=== Makefile ===

SM_DRIVERS := File
SM_DRIVERS += NFS
SM_DRIVERS += EXT
SM_DRIVERS += ISCSI
SM_DRIVERS += Dummy
SM_DRIVERS += udev
SM_DRIVERS += ISO
SM_DRIVERS += HBA
SM_DRIVERS += LVHD
SM_DRIVERS += LVHDoISCSI
SM_DRIVERS += LVHDoHBA
SM_DRIVERS += SHM

SM_LIBS := SR
SM_LIBS += SRCommand
SM_LIBS += VDI
SM_LIBS += cleanup
SM_LIBS += lvutil
SM_LIBS += lvmcache
SM_LIBS += util
SM_LIBS += scsiutil
SM_LIBS += scsi_host_rescan
SM_LIBS += vhdutil
SM_LIBS += lvhdutil
SM_LIBS += xs_errors
SM_LIBS += nfs
SM_LIBS += devscan
SM_LIBS += sysdevice
SM_LIBS += iscsilib
SM_LIBS += mpath_dmp
SM_LIBS += mpath_null
SM_LIBS += mpath_cli
SM_LIBS += mpathutil
SM_LIBS += LUNperVDI
SM_LIBS += mpathcount
SM_LIBS += refcounter
SM_LIBS += journaler
SM_LIBS += fjournaler
SM_LIBS += lock
SM_LIBS += flock
SM_LIBS += ipc
SM_LIBS += srmetadata
SM_LIBS += metadata
SM_LIBS += lvmanager
SM_LIBS += blktap2
SM_LIBS += mpp_mpathutil
SM_LIBS += mpp_luncheck
SM_LIBS += updatempppathd
SM_LIBS += lcache
SM_LIBS += resetvdis

CRON_JOBS := vmpr
CRON_JOBS += ringwatch

SM_XML := XE_SR_ERRORCODES

SM_DEST := /opt/xensource/sm/
DEBUG_DEST := /opt/xensource/debug/
BIN_DEST := /opt/xensource/bin/
MASTER_SCRIPT_DEST := /etc/xensource/master.d/
PLUGIN_SCRIPT_DEST := /etc/xapi.d/plugins/
LIBEXEC := /opt/xensource/libexec/
CRON_DEST := /etc/cron.d/

SM_STAGING := $(DESTDIR)
SM_STAMP := $(MY_OBJ_DIR)/.staging_stamp

.PHONY: build
	make -C dcopy 
	make -C snapwatchd
	make -C mpathroot

.PHONY: install
install: 
	mkdir -p $(SM_STAGING)
	$(call mkdir_clean,$(SM_STAGING))
	mkdir -p $(SM_STAGING)$(SM_DEST)
	mkdir -p $(SM_STAGING)$(DEBUG_DEST)
	mkdir -p $(SM_STAGING)$(BIN_DEST)
	mkdir -p $(SM_STAGING)$(MASTER_SCRIPT_DEST)
	mkdir -p $(SM_STAGING)$(PLUGIN_SCRIPT_DEST)
	mkdir -p $(SM_STAGING)/sbin
	for i in $(SM_LIBS); do \
	  install -m 755 drivers/$$i.py \
	    $(SM_STAGING)$(SM_DEST); done
	install -m 755 drivers/mpathHBA \
	  $(SM_STAGING)$(SM_DEST)
	for i in $(SM_DRIVERS); do \
	  install -m 755 drivers/$${i}SR.py \
	    $(SM_STAGING)$(SM_DEST); done
	for i in $(SM_XML); do \
	  install -m 755 drivers/$$i.xml \
	    $(SM_STAGING)$(SM_DEST); done
	cd $(SM_STAGING)$(SM_DEST) && for i in $(SM_DRIVERS); do \
	  ln -sf $$i"SR.py" $$i"SR"; \
	done
	rm $(SM_STAGING)$(SM_DEST)/SHMSR
	cd $(SM_STAGING)$(SM_DEST) && rm -f LVHDSR && ln -sf LVHDSR.py LVMSR
	cd $(SM_STAGING)$(SM_DEST) && rm -f LVHDoISCSISR && ln -sf LVHDoISCSISR.py LVMoISCSISR
	cd $(SM_STAGING)$(SM_DEST) && rm -f LVHDoHBASR && ln -sf LVHDoHBASR.py LVMoHBASR
	ln -sf $(SM_DEST)mpathutil.py $(SM_STAGING)/sbin/mpathutil
	install -m 755 drivers/02-vhdcleanup $(SM_STAGING)$(MASTER_SCRIPT_DEST)
	install -m 755 drivers/lvhd-thin $(SM_STAGING)$(PLUGIN_SCRIPT_DEST)
	install -m 755 drivers/on-slave $(SM_STAGING)$(PLUGIN_SCRIPT_DEST)
	install -m 755 drivers/testing-hooks $(SM_STAGING)$(PLUGIN_SCRIPT_DEST)
	install -m 755 drivers/coalesce-leaf $(SM_STAGING)$(PLUGIN_SCRIPT_DEST)
	install -m 755 drivers/nfs-on-slave $(SM_STAGING)$(PLUGIN_SCRIPT_DEST)
	install -m 755 drivers/tapdisk-pause $(SM_STAGING)$(PLUGIN_SCRIPT_DEST)
	install -m 755 drivers/vss_control $(SM_STAGING)$(PLUGIN_SCRIPT_DEST)
	ln -sf $(PLUGIN_SCRIPT_DEST)vss_control $(SM_STAGING)$(SM_DEST)
	install -m 755 drivers/iscsilib.py $(SM_STAGING)$(SM_DEST)
	mkdir -p $(SM_STAGING)$(LIBEXEC)
	install -m 755 scripts/local-device-change $(SM_STAGING)$(LIBEXEC)
	install -m 755 scripts/check-device-sharing $(SM_STAGING)$(LIBEXEC)
	$(MAKE) -C dcopy install DESTDIR=$(SM_STAGING)
	$(MAKE) -C snapwatchd install DESTDIR=$(SM_STAGING)
	$(MAKE) -C mpathroot install DESTDIR=$(SM_STAGING)
	ln -sf $(SM_DEST)blktap2.py $(SM_STAGING)$(BIN_DEST)/blktap2
	install -m 755 -d $(SM_STAGING)$(CRON_DEST)
	install -m 644 $(CRON_JOBS:%=etc/cron.d/%) -t $(SM_STAGING)$(CRON_DEST)
	install -m 755 drivers/runvmpr $(SM_STAGING)$(SM_DEST)
	install -m 755 drivers/vmpr $(SM_STAGING)$(PLUGIN_SCRIPT_DEST)
	ln -sf $(SM_DEST)lcache.py $(SM_STAGING)$(BIN_DEST)tapdisk-cache-stats
	cp -rf XenCert $(SM_STAGING)$(DEBUG_DEST)

.PHONY: clean
clean:
	rm -rf $(SM_STAGING)

=== dcopy/Makefile ===
PREFIX ?= /opt/xensource/libexec
DESTDIR ?= 
DEBUGDIR ?= /opt/xensource/debug


OPTS := -D _GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE -Wall

SRC := dcopy.c
SRC += atomicio.c

BIN := dcopy

all: dcopy tp

dcopy: dcopy.c
	$(CC) $(OPTS) $(SRC) -o $(BIN)

tp: tp.c
	$(CC) $(OPTS) tp.c -o tp

test: tp
	./test.sh

install: install_dcopy install_tp

install_dcopy: dcopy
	mkdir -p $(DESTDIR)$(PREFIX)
	install -m 755 $^ $(DESTDIR)$(PREFIX)

install_tp: tp
	mkdir -p $(DESTDIR)$(DEBUGDIR)
	install -m 755 $^ $(DESTDIR)$(DEBUGDIR)	

clean: 
	rm -f dcopy tp *.o source_img dest_img

=== mk/Makefile ===
USE_BRANDING := yes
IMPORT_BRANDING := yes
IMPORT_VERSIONS := yes
REPONAME := sm

include $(B_BASE)/common.mk
include $(B_BASE)/rpmbuild.mk

-include $(MY_OBJ_DIR)/version.inc
.PHONY: $(MY_OBJ_DIR)/version.inc
$(MY_OBJ_DIR)/version.inc:
	$(version-makefile) > $@
	$(call hg_cset_number,$(REPONAME)) >> $@
	echo SM_VERSION := \$$\(PLATFORM_VERSION\) >> $@
	echo SM_RELEASE := xs\$$\(CSET_NUMBER\) >> $@

SM_SPEC := sm.spec
SM_SRC := $(RPM_SOURCESDIR)/sm-$(SM_VERSION).tar.gz
SM_SRPM := sm-$(SM_VERSION)-$(SM_RELEASE).src.rpm
SM_STAMP := $(MY_OBJ_DIR)/.rpmbuild.stamp
ERRORCODES_XML := XE_SR_ERRORCODES.xml
SM_TESTS := $(MY_OUTPUT_DIR)/storage-manager-tests.tar
REPO := $(call hg_loc,sm)


.PHONY: build
build: sources $(SM_STAMP) $(SM_TESTS) $(MY_OUTPUT_DIR)/$(ERRORCODES_XML)

$(MY_SOURCES)/MANIFEST: $(RPM_SRPMSDIR)/$(SM_SRPM) $(MY_SOURCES_DIRSTAMP) $(RPM_BUILD_COOKIE)
	rm -f $@
	/bin/sh ./srpms-to-manifest api-libs $(MY_OUTPUT_DIR)/SRPMS > $@

.PHONY: sources
sources: $(MY_SOURCES)/MANIFEST

.PHONY: clean
clean:
	rm -f $(SM_STAMP) $(SM_SRC) $(RPM_SPECSDIR)/$(SM_SPEC)

.SECONDARY: $(SM_SRC)
$(SM_SRC): $(SM_SOURCES)
	echo SM_VERSION $(SM_VERSION) PLATFORM_VERSION $(PLATFORM_VERSION)
	hg archive -p sm-$(SM_VERSION) -t tbz2 $(RPM_SOURCESDIR)/sm-$(SM_VERSION).tar.bz2

.SECONDARY: $(RPM_SPECSDIR)/%.spec
$(RPM_SPECSDIR)/%.spec: *.spec.in
	sed -e 's/@SM_VERSION@/$(SM_VERSION)/g' \
          -e 's/@SM_RELEASE@/$(SM_RELEASE)/g' \
          < $< \
          > $@

$(RPM_SRPMSDIR)/$(SM_SRPM): $(RPM_DIRECTORIES) $(RPM_SPECSDIR)/$(SM_SPEC) $(SM_SRC)
	$(RPMBUILD) -bs $(RPM_SPECSDIR)/$(SM_SPEC)

$(SM_STAMP): $(RPM_SRPMSDIR)/$(SM_SRPM)
	$(RPMBUILD) --rebuild --target $(DOMAIN0_ARCH_OPTIMIZED) $(RPM_SRPMSDIR)/$(SM_SRPM)
	mkdir -p $(MY_MAIN_PACKAGES)
	cp $(RPM_RPMSDIR)/$(DOMAIN0_ARCH_OPTIMIZED)/sm-*.rpm $(MY_MAIN_PACKAGES)
	# Deliberately omit the debuginfo RPM (sm-debuginfo-...)
	rm -f $(MY_MAIN_PACKAGES)/sm-debuginfo-*.rpm
	touch $@

$(SM_TESTS): 
	rm -f $@
	tar -cf $@ -C $(REPO) tests

$(MY_OUTPUT_DIR)/$(ERRORCODES_XML):
	rm -f $@
	cp $(REPO)/drivers/$(ERRORCODES_XML) $@

=== mpathroot/Makefile ===
INITDIR ?= /etc/rc.d/init.d
DESTDIR ?= 

.PHONY: all
all:

.PHONY: install
install: mpathroot.init
	cp mpathroot.init $(DESTDIR)$(INITDIR)/mpathroot
	chmod +x $(DESTDIR)$(INITDIR)/mpathroot

.PHONY: clean
clean:

=== snapwatchd/Makefile ===
XS_INCLUDE ?= /usr/include
XS_LIB     ?= -lxenstore

PREFIX ?= /opt/xensource/sm/snapwatchd
INITDIR ?= /etc/rc.d/init.d
DESTDIR ?= 

PYTHON_INCLUDE ?= /usr/include/python2.4

CFLAGS ?= -O2
CFLAGS += -I$(PYTHON_INCLUDE) -I$(XS_INCLUDE)

SWIG ?= swig

.PHONY: all
all: _xslib.so
	@ :

.PHONY: install
install: _xslib.so xslib.py snapwatchd
	mkdir -p $(DESTDIR)$(PREFIX)
	install -m 644 $^ $(DESTDIR)$(PREFIX)
	chmod +x $(DESTDIR)$(PREFIX)/snapwatchd
	mkdir -p $(DESTDIR)$(INITDIR)
	cp snapwatchd.init $(DESTDIR)$(INITDIR)/snapwatchd
	chmod +x $(DESTDIR)$(INITDIR)/snapwatchd

%.py %_wrap.c: %.i
	$(SWIG) -python $<

_xslib.so: xslib.py xslib_wrap.o xslib.o
	$(CC) $(CFLAGS) -shared xslib.o xslib_wrap.o $(XS_LIB) -o $@

.PHONY: clean
clean:
	rm -f _xslib.so xslib_wrap.c xslib_wrap.o xslib.py xslib.o

=== tests/faultinjection/Makefile ===

LIBIPQ_INCLUDES := -I.
LIBIPQ_SOURCE = libipq.c libipq/libipq.h 
LIBIPQ_SVN=http://svn.netfilter.org/netfilter/trunk/iptables

CC := gcc
CFLAGS := -Wall -O2 -m32
CPPFLAGS := $(LIBIPQ_INCLUDES)
LDFLAGS := -static -m32

PROGRAMS = pfilter

all: $(PROGRAMS)


pfilter: pfilter.o libipq.o
	$(CC) $^ $(LDFLAGS) -o $@

pfilter.c: $(LIBIPQ_SOURCE)

libipq.o: $(LIBIPQ_SOURCE)


libipq.c:
	wget -q -O$@ $(LIBIPQ_SVN)/libipq/libipq.c

libipq/libipq.h:
	-[ -d libipq ] || mkdir libipq
	wget -q -O$@ $(LIBIPQ_SVN)/include/libipq/libipq.h

clean:
	rm -f $(PROGRAMS) *.o
	rm -f *~
	rm -f $(LIBIPQ_SOURCE)

=== debian/changelog ===
xcp-storage-managers (0.1.1-3) unstable; urgency=low

  * Added missing dependency on sg3-utils and open-iscsi (Closes: #691806).
  * Fixes path to iscsid in iscsilib.py (Closes: #691805).
  * Fixes path to scsi_id in scsiutil.py, removes unknown --master parameter in
  lvutil.py (Closes: #691808).
  * Fix CDROM guest hotplug bug (LP: #1045739) (Closes: #687319).
  * Added a watch file.
  * Build-Conflicts: xcp-storage-managers, since that's just what happened to
  me at the dh_python2 stage.

 -- Thomas Goirand <zigo@debian.org>  Sun, 04 Nov 2012 18:54:52 +0000

xcp-storage-managers (0.1.1-2) unstable; urgency=low

  * New FHS compliant layout
  * Initial release (Closes: #646722)

 -- Jon Ludlam <jonathan.ludlam@eu.citrix.com>  Wed, 07 Dec 2011 17:25:32 +0000

=== debian/control ===
Source: xcp-storage-managers
Section: libs
Priority: extra
Maintainer: PKG-Xen Devel <pkg-xen-devel@lists.alioth.debian.org>
Uploaders: Thomas Goirand <zigo@debian.org>, Jon Ludlam <jonathan.ludlam@eu.citrix.com>, Mike McClurg <mike.mcclurg@citrix.com>
Build-Depends: debhelper (>= 8), swig, python-all-dev, libxen-dev, python-all (>= 2.6.6-3~)
Build-Conflicts: xcp-storage-managers
Standards-Version: 3.9.2
X-Python-Version: >= 2.6
VCS-Git: http://anonscm.debian.org/git/pkg-xen/xcp-storage-managers.git
VCS-Browser: http://anonscm.debian.org/gitweb/?p=pkg-xen/xcp-storage-managers.git
Homepage: http://www.xen.org/products/cloudxen.html

Package: xcp-storage-managers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, uuid-runtime, blktap-utils, sg3-utils, open-iscsi
Recommends: lvm2, nfs-common
Description: storage backends for XCP
 The Xen Cloud Platform (XCP) is an open source enterprise-ready server
 virtualization and cloud computing platform, with support for a range of
 guest operating systems, Linux network and storage support.
 .
 XCP addresses the needs of cloud providers, hosting services and data centers
 by combining the isolation and multitenancy capabilities of the Xen hypervisor
 with enhanced security, storage and network virtualization technologies to
 offer a rich set of virtual infrastructure cloud services. The platform
 also address user requirements for security, availability, performance and
 isolation across both private and public clouds.
 .
 XCP consolidates server workloads, enables savings in power, cooling, and
 management costs and thus contributing to environmentally sustainable
 computing, an increased ability to adapt to ever-changing IT environments,
 an optimized use of existing hardware, and an improved level of IT
 reliability.
 .
 This package provides storage backend plugins for various storage types that
 XCP supports.

=== debian/watch ===
version=3
http://github.com/mcclurmc/xcp-storage-managers/tags /mcclurmc/xcp-storage-managers/tarball/master/(.+)

## xcp-storage-managers 0.1.2

=== debian/changelog ===
xcp-storage-managers (0.1.2-2) unstable; urgency=low

  * BUG: remove --master arg from calls to lvm

 -- Mike McClurg <mike.mcclurg@citrix.com>  Fri, 20 Jan 2012 17:29:32 +0000

xcp-storage-managers (0.1.2-1) unstable; urgency=low

  * Upstream version bump

 -- Mike McClurg <mike.mcclurg@citrix.com>  Sat, 07 Jan 2012 22:34:21 +0000

xcp-storage-managers (0.1.1-5) unstable; urgency=low

  * xapi-autobuilder automatic changelog bump

 -- Mike McClurg <mike.mcclurg@citrix.com>  Thu, 22 Dec 2011 12:49:48 +0000

xcp-storage-managers (0.1.1-4) oneiric; urgency=low

  * Use python2.7 rather than 2.6

 -- Jonathan Ludlam <jonathan.ludlam@eu.citrix.com>  Wed, 21 Dec 2011 12:56:55 +0000

=== debian/control ===
--- 
+++ 
@@ -3,17 +3,16 @@
 Priority: extra
 Maintainer: PKG-Xen Devel <pkg-xen-devel@lists.alioth.debian.org>
 Uploaders: Thomas Goirand <zigo@debian.org>, Jon Ludlam <jonathan.ludlam@eu.citrix.com>, Mike McClurg <mike.mcclurg@citrix.com>
-Build-Depends: debhelper (>= 8), swig, python-all-dev, libxen-dev, python-all (>= 2.6.6-3~)
-Build-Conflicts: xcp-storage-managers
+Build-Depends: debhelper (>= 8), swig, python-all-dev (>= 2.7), libxen-dev, python-all (>= 2.7)
 Standards-Version: 3.9.2
-X-Python-Version: >= 2.6
+X-Python-Version: >= 2.7
 VCS-Git: http://anonscm.debian.org/git/pkg-xen/xcp-storage-managers.git
 VCS-Browser: http://anonscm.debian.org/gitweb/?p=pkg-xen/xcp-storage-managers.git
 Homepage: http://www.xen.org/products/cloudxen.html
 
 Package: xcp-storage-managers
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, uuid-runtime, blktap-utils, sg3-utils, open-iscsi
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, uuid-runtime, blktap-utils
 Recommends: lvm2, nfs-common
 Description: storage backends for XCP
  The Xen Cloud Platform (XCP) is an open source enterprise-ready server
